# -*- coding: utf-8 -*-

import Tkinter
import codecs
import locale

# check out the system encoding first; this is from phonoripper's UnicodeHandler module

def _find_codec(encoding):
    # return True if the requested codec is available, else return False
    try:
        codecs.lookup(encoding)
        return 1
    except (TypeError, LookupError):
        return 0

def _sysencoding():
    # try to guess the system default encoding
    # this is mainly stolen from IDLE's IOBinding.py
    # thanks for guidance to Martin v. Löwis
    locale.setlocale(locale.LC_CTYPE, "")# don't mess the numeric types here, we might replace the decimal point with a comma and break Tk!
    try:
        enc = locale.getpreferredencoding()
        if enc and _find_codec(enc):
            return enc
    except AttributeError:
        # our python is too old, try something else
        pass
    try:
        enc = locale.nl_langinfo(locale.CODESET)
        if enc and _find_codec(enc):
            return enc
    except AttributeError:
        pass
    # the last try
    try:
        enc = locale.getdefaultlocale()[1]
        if enc and _find_codec(enc):
            return enc
    except ValueError:
        pass
    # aargh, nothing good found, fall back to ascii and hope for the best
    print 'un-applet: warning: unable to find usable encoding, using ascii.'
    return 'ascii'

sysencoding = _sysencoding().lower()

def fsdecode(input, errors='replace'):
    '''Fail-safe decodes a string into unicode.'''
    if not isinstance(input, unicode):
        return unicode(input, sysencoding, errors)
    return input

def fsencode(input, errors='replace'):
    '''Fail-safe encodes a unicode string into system default encoding.'''
    if isinstance(input, unicode):
        return input.encode(sysencoding, errors)
    return input
